import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, Modal, Upload ,Popconfirm} from 'antd';
import MySettlementDetaile from "./projectOrderDetaile.jsx";
import moment from 'moment';
import '../userMangagement.less';
import {orderState} from '../../../../dataDic.js';
import {getPaymentState,getOrderState ,getOrderType   } from '../../../../tools.js';

const ProjectOrder=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/techproject/listSetUpServiceOrder',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                buyerName:this.state.buyerNameSearch,
                depId:this.state.departmenttSearch,//部门
                salesmanName:this.state.salesmanNameSearch,//负责人
				orderStatus:this.state.orderStatusSearch,
				financeName:this.state.financeNameSearch,
				approval:this.state.approvedSearch
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         orderNo: thisdata.orderNo,//订单编号
	                         orderType:thisdata.orderType,//订单类型
	                         orderStatus:thisdata.orderStatus,
	                         liquidationStatus:thisdata.liquidationStatus,
	                         createTime:thisdata.createTime,
	                         approval:thisdata.approval,
	                         salesmanName:thisdata.salesmanName,
	                         departmentName:thisdata.departmentName,
	                         financeName:thisdata.financeName,
	                         buyerName:thisdata.buyerName,
	                         projectStage:thisdata.projectStage
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                	pageNo:pageNo,
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[],
                    signBillVisible:false
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    //部门
	departmentList() {
		this.setState({
			loading: true
		});
		$.ajax({
			method: "post",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context + "/api/admin/organization/selectSuperId",
			data: {
				
			},
			success: function(data) {
				let thedata = data.data;
				let theArr=[];
				if(!thedata) {
					if(data.error && data.error.length) {
						message.warning(data.error[0].message);
					};
					thedata = {};
				}else{
					thedata.map(function(item,index){
						theArr.push({
							key:index,
							name:item.name,
							id:item.id,
						})
					})
				}
				this.setState({
					departmentArr:theArr,
				})
			}.bind(this),
			}).always(function() {
				this.setState({
					loading: false
				});
			}.bind(this));
	},
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            selectedRows: [],
            searchMore: true,
            loading: false,
            KnotState:true,
            distributionVisible:false,
            visible:false,
            showDesc:false,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo'
                },{
                    title: '下单时间',
                    dataIndex: 'createTime',
                    key: 'createTime'
                },{
                    title: '客户名称',
                    dataIndex: 'buyerName',
                    key: 'buyerName'
                },
                {
                    title: '订单类型',
                    dataIndex: 'orderType',
                    key: 'orderType',
                    render:(text)=>{return getOrderType(text) }
                }, {
                    title: '订单状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                    render:(text)=>{return getOrderState(text) }
                },{
                    title: '结算状态',
                    dataIndex: 'liquidationStatus',
                    key: 'liquidationStatus',
                    render:(text)=>{return getPaymentState(text) }
                }, {
                    title: '是否特批',
                    dataIndex: 'approval',
                    key: 'approval',
                    render:(text)=>{return text==2?'已特批':'未特批' }
                },{
                    title: '订单部门',
                    dataIndex: 'departmentName',
                    key: 'departmentName',
                },{
                    title: '订单负责人',
                    dataIndex: 'salesmanName',
                    key: 'salesmanName',
                },{
                    title: '财务负责人',
                    dataIndex: 'financeName',
                    key: 'financeName',
                },{
                	title: '操作',
                    dataIndex: 'rr',
                    key: 'rr',
                    render:(text,record,index)=>{
                    	return (
                    		<div >
								{record.projectStage<2&&<Button style={{marginRight:'5px'}} type="primary" onClick={(e) =>{ e.stopPropagation(),this.edit(record) }}>立项</Button>}                 
								{record.projectStage>=2&&<Button style={{marginRight:'5px'}} type="primary" onClick={(e) =>{ e.stopPropagation(),this.Knot(record)}}>结项</Button>}                 
							</div>
							)
                    }
                }
            ],
            dataSource: [],
        };
    },
    componentWillMount() {
    	this.departmentList()
        this.loadData();
    },
    //立项
    edit(record) {
    	this.setState({
    		KnotState:true,
    		signBillVisible:true
    	})
    	this.editData(record,1)
    },
    //结项
    Knot(record){
    	this.setState({
    		KnotState:false,
    		signBillVisible:true
    	})
    	this.editData(record,0)
    },
    noProject(){
    	this.setState({
    		signBillVisible:false
    	})
    },
    //立项。结项前数据获取
    editData(xhr,state){
    	let api =state?'/api/admin/techproject/toSetUpProject':'api/jiexiang-shuju';
    	$.ajax({
			method: "get",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context + api,
			data: {
				orderNo:xhr.orderNo,
				buyerName:xhr.buyerName
			},
			success: function (data) {
				let theData=data.data;
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                   this.setState({
                   		uid:theData.id,
                   		orderNo:theData.orderNo,
                   		buyerName:theData.buyerName,
                   		signDate:theData.signDate,
                   		signComment:''
                   })
                };
			}.bind(this)},
    	).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    //立项、结项保存操作
	projectSubmit(e){
		e.preventDefault();
		this.setState({
			loading: true
		});
		let api=this.state.KnotState?'/api/admin/techproject/setUpProject':'/api/admin/jiexiang';
		$.ajax({
			method: "get",
			dataType: "json",
			crossDomain: false,
			url: globalConfig.context +api ,
			data: {
				orderNo:this.state.orderNo,
				signDate:this.state.signDate,
				signComment:this.state.signComment,
			}
		}).done(function(data) {
			this.setState({
				loading: false
			});
			if(!data.error.length) {
				message.success('操作成功！');
				this.noProject();
				this.loadData(this.state.pageNo);			
			} else {
				message.warning(data.error[0].message);
			}
		}.bind(this));
	},
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.pageNo);	
        };
    },
    searchSwitch() {
		this.setState({
			searchMore: !this.state.searchMore
		});
	},
    search() {
        this.loadData();
    },
    tableRowClick(record, index) {
        this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
            showDesc: true
        });
    },
    reset() {
    	this.state.buyerNameSearch='';
		this.state.approvedSearch = undefined;
		this.state.orderStatusSearch = undefined;
		this.state.departmenttSearch = undefined;
		this.state.salesmanNameSearch = '';
		this.state.financeNameSearch = '';
        this.loadData();       
    },
    render() {
    	const FormItem = Form.Item;
    	const formItemLayout = {
			labelCol: { span: 8 },
			wrapperCol: { span: 14 },
		};
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
         let departmentArr = this.state.departmentArr || [];
        const hasSelected = this.state.selectedRowKeys.length > 0;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>立项订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.buyerNameSearch  }
	                        onChange={(e) => { this.setState({ buyerNameSearch  : e.target.value }); }} />
	                    <Select placeholder="是否特批"
	                        style={{ width: 150 ,marginRight:'10px'}}
	                        value={this.state.approvedSearch }
	                        onChange={(e) => { this.setState({ approvedSearch : e }) }}>
	                        <Select.Option value='0'>未特批</Select.Option>
	                        <Select.Option value='1'>已特批</Select.Option>
                  		</Select>
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索</Button>
	                    <Button onClick={this.reset}>重置</Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}> 
	                    <Select placeholder="订单部门"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.departmenttSearch}
	                            onChange={(e) => { this.setState({ departmenttSearch: e }) }}>
	                            {
                                    departmentArr.map(function (item) {
                                            return <Select.Option key={item.id} >{item.name}</Select.Option> 
                                    })
                                }
	                    </Select>
	                        <Input placeholder="订单负责人" style={{width:'150px',marginRight:'10px'}}
		                        value={this.state.salesmanNameSearch }
		                        onChange={(e) => { this.setState({ salesmanNameSearch : e.target.value }); }} />
	                        <Input placeholder="财物负责人" style={{width:'150px'}}
		                        value={this.state.financeNameSearch}
		                        onChange={(e) => { this.setState({ financeNameSearch: e.target.value }); }} />
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick}
	                            />
	                    </Spin>
	                </div>
	                <MySettlementDetaile
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
	            <Modal maskClosable={false} visible={this.state.signBillVisible}
                        onOk={this.noProject} onCancel={this.noProject}
                        width='800px'
                        title={this.state.KnotState?'项目立项':'项目结项'}                   
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" onSubmit={this.projectSubmit} id="demand-form">
			                <Spin spinning={this.state.loading}>
			                        <div className="clearfix">
					                    <FormItem className="half-item"
					                            {...formItemLayout}
					                            label="项目编号" >   
				                                   <span>{this.state.orderNo}</span>
					                    </FormItem>
					                    <FormItem className="half-item"
					                            {...formItemLayout}
					                            label="客户名称" >   
				                                   <span>{this.state.buyerName}</span>
					                    </FormItem>
					                    <FormItem className="half-item"
					                            {...formItemLayout}
					                            label={this.state.KnotState?"立项时间":'结项时间'}>   
				                                   <span>{this.state.signDate}</span>
					                    </FormItem>
						                <div className='clearfix'>
								        	<FormItem
									            labelCol={{ span: 4 }}
									            wrapperCol={{ span: 16 }}
									            label={this.state.KnotState?"立项说明":'结项说明'} >
									                <Input type="textarea" placeholder="请输入备注" rows={4}  value={this.state.signComment} 
										    				onChange={(e)=>{this.setState({signComment:e.target.value})}}/>			                      
									        </FormItem>
								        </div>
				                    </div>
			                    <FormItem wrapperCol={{ span: 12, offset: 4 }} className="half-middle">
			                        <Button className="submitSave" type="primary" htmlType="submit">{this.state.KnotState?"确定立项":'确定结项'}</Button>  
			                        <Button className="submitSave" type="ghost" onClick={this.noProject}>返回</Button>
			                    </FormItem> 
			                </Spin>
			            </Form >
			        </Modal>
            </div>
        );
    }
}));

export default ProjectOrder;

